#_____IMPORTE

from Tkinter import *
from random import *
import time

#_____VARIABLEN


#HPP_Gas, super macht Verdichtung mit, die anderen Gase nicht, reversibel
Kennziffer = ['0', '8', '4', '12', '2', '10', '9', '14', '1', '6', '5',\
              '13', '3', '11', '7', '15']

Seitenlaenge = 100

Zellauftrittswahrscheinlichkeit =  10
Verdichtung = 65

Zellgroesse = 3
Farbe = "black"

Wartezeit = 0

#_____SPIELFELD UND ZELLEN

Spielfeld = [ (Seitenlaenge) * [0] for i in range(Seitenlaenge) ]

for Zeile in range(Seitenlaenge):
    for Spalte in range(Seitenlaenge):
        Spielfeld[Zeile][Spalte] = int ( random() + ( float ( Zellauftrittswahrscheinlichkeit ) / 100 ) )

# Verdichtete Stelle an der SEITE LINNKS wird noch einmal besetzt mit hoeherem Wert
for i in range(Seitenlaenge):
    for j in range(0, int(Seitenlaenge/6)):
        Spielfeld[i][j] = int ( random() + (float ( Verdichtung ) / 100 ) )

Spielfeld[50][52] = 1

#_____TRIGGER

Trigger = -1

#_____CANVAS

master = Tk()

w = Canvas(master, width=(4 + (Seitenlaenge * Zellgroesse) + 1),\
           height= (4 + (Seitenlaenge * Zellgroesse) + 1) )
w.pack()

done = 0
    
def finish(e):
    global done
    done = 1
    
master.bind("<Control-c>", finish)
    
while not done:

#_____PROGRAMM

    # Auswahl des Gitters

    Trigger = Trigger * -1

    if Trigger == 1:   
        Gitterverschiebung = 0               
    else:                   
        Gitterverschiebung = 1              

    Zeile = Gitterverschiebung
    Spalte = Gitterverschiebung

    # Hauptschleife
                                                 
    while Zeile < Seitenlaenge - 1:
        Spalte = Gitterverschiebung                  
        while Spalte < Seitenlaenge - 1:

    #_____LESEN des alten Blocks
            
            Zelle0 = (Spielfeld[Zeile][Spalte])      
            Zelle1 = (Spielfeld[Zeile][Spalte+1])    
            Zelle2 = (Spielfeld[Zeile+1][Spalte])   
            Zelle3 = (Spielfeld[Zeile+1][Spalte+1])  
        
    #_____SYNTHESE des alten BLocks

            Alter_Block =  (Zelle3 * 8) + (Zelle2 * 4) + (Zelle1 * 2) + (Zelle0 * 1)

    #_____REGELANWENDUNG

            Neuer_Block = int(Kennziffer[Alter_Block])

    #_____AMALYSE der Nummer des neuen Blocks
    
            if Neuer_Block >= 8: 
                Zelle3 = 1 
                Neuer_Block = Neuer_Block - 8  
            else: 
                Zelle3 = 0 
 
            if Neuer_Block >= 4:                
                Zelle2 = 1                     
                Neuer_Block = Neuer_Block - 4
            else:
                Zelle2 = 0

            if Neuer_Block >= 2:                
                Zelle1 = 1
                Neuer_Block = Neuer_Block - 2
            else:
                Zelle1 = 0

            if Neuer_Block >= 1:                
                Zelle0 = 1                     
            else: 
                Zelle0 = 0 

    #_____SCHREIBEN des neuen Blocks

            (Spielfeld[Zeile][Spalte]) = Zelle0
            (Spielfeld[Zeile][Spalte+1]) = Zelle1
            (Spielfeld[Zeile+1][Spalte]) = Zelle2
            (Spielfeld[Zeile+1][Spalte+1]) = Zelle3
        
            Spalte = Spalte + 2
        Zeile = Zeile + 2

    #_____WARTEZEIT
    time.sleep( float (Wartezeit) / 1000)


    #_____GRAPHISCHE AUSGABE
    #        Canvas wird mit der neuen Generation von Zellen bemalt

    w.delete(ALL)

    for Zeile in range(Seitenlaenge):
        for Spalte in range(Seitenlaenge):
            if Spielfeld[Zeile][Spalte] == 1:
                w.create_rectangle((Spalte*Zellgroesse) + 4, (Zeile*Zellgroesse)+(Zellgroesse + 4), \
                                   (Spalte*Zellgroesse)+(Zellgroesse + 4), (Zeile*Zellgroesse) + 4, \
                                   fill=Farbe, outline=Farbe)

    
    master.update()

