#_____IMPORTE

from Tkinter import *
from random import *
import time

#_____VARIABLEN

#BBM; reversibel
Kennziffer = ['0', '8', '4', '3', '2', '5', '9', '7', '1', '6', '10',\
              '11', '12', '13', '14', '15']

Seitenlaenge = 140

Zellauftrittswahrscheinlichkeit =  0
Verdichtung = 0

Zellgroesse = 3
Farbe = "black"

Wartezeit = 0

#_____SPIELFELD UND ZELLEN

Spielfeld = [ (Seitenlaenge) * [0] for i in range(Seitenlaenge) ]

for Zeile in range(Seitenlaenge):
    for Spalte in range(Seitenlaenge):
        Spielfeld[Zeile][Spalte] = int ( random() + ( float ( Zellauftrittswahrscheinlichkeit ) / 100 ) )

for Zeile in range(int(Seitenlaenge/3), int(Seitenlaenge/3*2)):
    for Spalte in range(int(Seitenlaenge/3), int(Seitenlaenge/3*2)):
        Spielfeld[Zeile][Spalte] = int ( random() + ( float ( Verdichtung ) / 100 ) )

# Signale

Spielfeld[40][69] = 1
Spielfeld[42][67] = 1

Spielfeld[40][70] = 1
Spielfeld[42][72] = 1

Spielfeld[8][56] = 1
Spielfeld[6][54] = 1

Spielfeld[8][83] = 1
Spielfeld[6][85] = 1

# Reflektoren

# Reflektor 1a
for Zeile in range (17, 25):
   for Spalte in range (46, 48):
        Spielfeld[Zeile][Spalte] = 1
        
# Reflektor 1b
for Zeile in range (17, 25):
   for Spalte in range (92, 94):
        Spielfeld[Zeile][Spalte] = 1

#Reflektor 2a
for Zeile in range (87, 91):
   for Spalte in range (18, 20):
        Spielfeld[Zeile][Spalte] = 1

# Reflektor 2b
for Zeile in range (87, 91):
   for Spalte in range (120, 122):
        Spielfeld[Zeile][Spalte] = 1

# Reflektor 3a
for Zeile in range (97, 101):
   for Spalte in range (32, 34):
        Spielfeld[Zeile][Spalte] = 1

# Reflektor 3b
for Zeile in range (97, 101):
   for Spalte in range (106, 108):
        Spielfeld[Zeile][Spalte] = 1


# Reflektor 4a
for Zeile in range (107, 111):
   for Spalte in range (18, 20):
        Spielfeld[Zeile][Spalte] = 1

# Reflektor 4b
for Zeile in range (107, 111):
   for Spalte in range (120, 122):
        Spielfeld[Zeile][Spalte] = 1

# Reflektor Ende a
for Zeile in range (9, 13):
   for Spalte in range (60, 62):
        Spielfeld[Zeile][Spalte] = 1

# Reflektor Ende b
for Zeile in range (9, 13):
   for Spalte in range (78, 80):
        Spielfeld[Zeile][Spalte] = 1

# Reflektor Breit a
for Zeile in range (0, 2):
   for Spalte in range (49,55):
        Spielfeld[Zeile][Spalte] = 1        
        
# Reflektor Breit b
for Zeile in range (0, 2):
   for Spalte in range (85, 91):
        Spielfeld[Zeile][Spalte] = 1 

#_____TRIGGER

Trigger = -1

#_____CANVAS

master = Tk()

w = Canvas(master, width=(4 + (Seitenlaenge * Zellgroesse) + 1),\
           height= (4 + (Seitenlaenge * Zellgroesse) + 1) )
w.pack()

done = 0
    
def finish(e):
    global done
    done = 1
    
master.bind("<Control-c>", finish)
    
while not done:

#_____PROGRAMM

    # Auswahl des Gitters

    Trigger = Trigger * -1

    if Trigger == 1:   
        Gitterverschiebung = 0               
    else:                   
        Gitterverschiebung = 1              

    Zeile = Gitterverschiebung
    Spalte = Gitterverschiebung

    # Hauptschleife
                                                 
    while Zeile < Seitenlaenge - 1:
        Spalte = Gitterverschiebung                  
        while Spalte < Seitenlaenge - 1:

    #_____LESEN des alten Blocks
            
            Zelle0 = (Spielfeld[Zeile][Spalte])      
            Zelle1 = (Spielfeld[Zeile][Spalte+1])    
            Zelle2 = (Spielfeld[Zeile+1][Spalte])   
            Zelle3 = (Spielfeld[Zeile+1][Spalte+1])  
        
    #_____SYNTHESE des alten BLocks

            Alter_Block =  (Zelle3 * 8) + (Zelle2 * 4) + (Zelle1 * 2) + (Zelle0 * 1)

    #_____REGELANWENDUNG

            Neuer_Block = int(Kennziffer[Alter_Block])

    #_____AMALYSE der Nummer des neuen Blocks
    
            if Neuer_Block >= 8: 
                Zelle3 = 1 
                Neuer_Block = Neuer_Block - 8  
            else: 
                Zelle3 = 0 
 
            if Neuer_Block >= 4:                
                Zelle2 = 1                     
                Neuer_Block = Neuer_Block - 4
            else:
                Zelle2 = 0

            if Neuer_Block >= 2:                
                Zelle1 = 1
                Neuer_Block = Neuer_Block - 2
            else:
                Zelle1 = 0

            if Neuer_Block >= 1:                
                Zelle0 = 1                     
            else: 
                Zelle0 = 0 

    #_____SCHREIBEN des neuen Blocks

            (Spielfeld[Zeile][Spalte]) = Zelle0
            (Spielfeld[Zeile][Spalte+1]) = Zelle1
            (Spielfeld[Zeile+1][Spalte]) = Zelle2
            (Spielfeld[Zeile+1][Spalte+1]) = Zelle3
        
            Spalte = Spalte + 2
        Zeile = Zeile + 2

    #_____WARTEZEIT
    time.sleep( float (Wartezeit) / 1000)


    #_____GRAPHISCHE AUSGABE
    #        Canvas wird mit der neuen Generation von Zellen bemalt

    w.delete(ALL)

    for Zeile in range(Seitenlaenge):
        for Spalte in range(Seitenlaenge):
            if Spielfeld[Zeile][Spalte] == 1:
                w.create_rectangle((Spalte*Zellgroesse) + 4, (Zeile*Zellgroesse)+(Zellgroesse + 4), \
                                   (Spalte*Zellgroesse)+(Zellgroesse + 4), (Zeile*Zellgroesse) + 4, \
                                   fill=Farbe, outline=Farbe)

    
    master.update()

